(defun c:li (/ geslge lge )
  (prompt "\nCopyright (c) by E. DIETRICH, A-2122 Ulrichskirchen ")
  (setq pktlist nil)
  (setq befehl nil)
  (setq geslge 0)
  (setq pktanz 0)
  (initget 128 "A P Y")
  (setq anfpkt (getpoint "\nPol(Y)linie/(A)ttribut/(P)ktnr/<<Anfangspunkt>>: "))		;Anfangspunkt
  (if (not anfpkt)
    (setq anfpkt (getvar "lastpoint"))
  )
  (setq npkt anfpkt)	;die Funktion '(abfrage)' arbeitet mit 'npkt'
  (abfrage)	;diese Funktion verzweigt zu den weiteren Funktionen je nach Eingabe
  (if (= (type anfpkt) 'STR)
    (setq anfpkt npkt)	;die Funktionen liefern die Pktkoord. als 'npkt'
  )
  (setq osm (getvar "OSMODE"))
  (setvar "OSMODE" 0)
  (if (= befehl "poly")
    (command "_.PLINE" anfpkt)
    (command "_.LINE" anfpkt)
  )
  (setvar "OSMODE" osm)
  (setq pktlist (list anfpkt))
  (setq npkt T)
  (setq pktanz 1)
  (initget 128 "Z A P T PA")
  (setq npkt (getpoint (car pktlist) "\nRich(T)ung/(PA)rallel/(A)ttribut/(P)ktnr/(Z)urck/<<Nchster Punkt>>: ")) 	;Zweiter Punkt
    (while npkt
      (abfrage)
      (setq osm (getvar "OSMODE"))
				;;; Korr2000 - WARNING: The OSMODE sysvar has changed.
      (setvar "OSMODE" 0)
      (command npkt)
				;;; Korr2000 - WARNING: The OSMODE sysvar has changed.
      (setq pktanz (1+ pktanz))
      (setvar "OSMODE" osm)
      (if (not (= npkt "_U"))
        (progn
          (princ (strcat "\nEntfernung: " (rtos (setq lge (distance (car pktlist) npkt))2 3) "\t\tGesamtlnge: " (rtos (setq geslge (+ geslge lge)) 2 2)))
          (setq pktlist (cons npkt pktlist))
        )
      )
      (setq richt (angle (setq vlpkt (cadr pktlist)) (setq lpkt (car pktlist))))
      (eingabe)
    )
  (command "")
  (princ "\nDanke")
  (princ)
)
;---------------------------------------------------------------------------
(defun abfrage ()
  (cond 
    ((= npkt "R") (rechts))
    ((= npkt "L") (links))
    ((= npkt "G") (gerade))
    ((= npkt "A") (attribut))
    ((= npkt "P") (pktnummer))
    ((= npkt "S") (schnitt))
    ((= npkt "T") (richtung))
    ((= npkt "Z") (back))
    ((= npkt "PA") (para))
    ((= npkt "Y") (poly))
    ((= npkt "") (setq npkt nil))
  )
)
;---------------------------------------------------------------------------
(defun eingabe ()
  (initget 128 "L R G T A P S Z PA")
  (setq npkt (getpoint (car pktlist) "\n(L)inks/(R)echts/(G)erade/Rich(T)ung/(PA)arallel/(A)ttribut/(P)ktnr/(S)chnitt/(Z)urck/<<Nchster Punkt>>: "))
  (if (= npkt "\n")
    (eingabe)
  )
)
;---------------------------------------------------------------------------
(defun schnitt (/ art linobj linname ppkt)
  (setq linobj (entsel "\nBis zu welcher Linie: "))
  (setq linname (car linobj))
  (setq art (cdr (assoc 0 (entget linname))))
  (if (not (or (= art "LINE") (= art "LWPOLYLINE")))
    (progn
      (setq linobj (entsel "\nDas war keine (Poly-)Linie - Bis zu welcher Linie: "))
      (setq linname (car linobj))
      (setq art (cdr (assoc 0 (entget linname))))
    )
  )
  (if (= art "LWPOLYLINE")
    (progn
      (setq ppkt (cadr linobj))
      (polyanalyse ppkt (plist linname))
    )
  )
  (if (= art "LINE")
    (progn
      (setq p1 (cdr (assoc 10 (entget linname))))
      (setq p2 (cdr (assoc 11 (entget linname))))
    )
  )
  (setq osm (getvar "OSMODE"))
  (setvar "OSMODE" 0)
  (setq npkt (inters p1 p2 lpkt vlpkt nil))
  (setvar "OSMODE" osm)
)
;---------------------------------------------------------------------------
(defun poly ()
  (setq befehl "poly")
  (princ "\nErzeuge eine Polylinie !")
  (initget 128 "A P")
  (setq anfpkt (getpoint "\n(A)ttribut/(P)ktnr/<<Anfangspunkt>>: "))		;Anfangspunkt
  (if (not anfpkt)
    (setq anfpkt (getvar "lastpoint"))
  )
  (setq npkt anfpkt)	;die Funktion '(abfrage)' arbeitet mit 'npkt'
  (abfrage)
)
;---------------------------------------------------------------------------
(defun pktnum ()
  (setq npkt (pktnummer))
)
;---------------------------------------------------------------------------
(defun attribut (/ objname)
  (setq objname (car (entsel "\nPunktattribut anklicken: ")))
  (princ (strcat "\nPunkt-Nr.: " (pktdat objname 1)))
  (setq npkt (pktdat objname 6))
)
;---------------------------------------------------------------------------
(defun links ()
  (print "Links")
  (setq richt (+ richt (/ pi 2)))
  (setq strecke (getdist (getvar "LASTPOINT") "\nWie weit <Eingabe in cm>: "))
  (if (not strecke)
    (setq strecke (zenti))
  )
  (setq npkt (polar (getvar "LASTPOINT") richt strecke))
)
;---------------------------------------------------------------------------
(defun rechts ()
  (print "Rechts")
  (setq richt (- richt (/ pi 2)))
  (setq strecke (getdist (getvar "LASTPOINT") "\nWie weit <Eingabe in cm>: "))
  (if (not strecke)
    (setq strecke (zenti))
  )
  (setq npkt (polar (getvar "LASTPOINT") richt strecke))
)
;---------------------------------------------------------------------------
(defun gerade ()
  (print "Gerade")
  (setq strecke (getdist (getvar "LASTPOINT") "\nWie weit <Eingabe in cm>: "))
  (if (not strecke)
    (setq strecke (zenti))
  )
  (setq npkt (polar (getvar "LASTPOINT") richt strecke))
)
;---------------------------------------------------------------------------
(defun back ()
  (print "Zurck")
  (setq npkt "_U")
  (setq pktlist (cdr pktlist))
)
;---------------------------------------------------------------------------
(defun richtung ()
  (setq P1 (car pktlist))
  (initget 128 "A P PA")
  (setq P2 (getpoint P1 "\n(A)ttribut/(P)ktnr/(PA)rallel/<<Richtungspunkt>>:"))
  (setq npkt P2)	;die Funktion '(abfrage)' arbeitet mit 'npkt'
  (abfrage)
  (if (= (type P2) 'STR)
    (setq P2 npkt)	;die Funktionen liefern die Pktkoord. als 'npkt'
  )
  (setq P1P2 (distance P1 P2))
  (setq p1p0 nil)
  (princ "\nEntfernung: ")
  (princ P1P2)
  (princ "m oder in cm: ")
  (princ (/ P1P2 (/ (scale) 100)))
  (setq p1p0 (getdist "\nWie weit <Eingabe in cm>:"))
  (if (not p1p0)
    (setq p1p0 (zenti))
  )
  (setq npkt (polar P1 (angle P1 P2) p1p0))
)
;---------------------------------------------------------------------------
(defun pktdat (ename art / pktnrdat hdat pktnr h y x elev einfpkt)
  (setq einfpkt (cdr (assoc 10 (entget ename))))	;Einfgepkt
  (setq y (car einfpkt))                        ;y-Koordinate
  (setq x (cadr einfpkt))			;x-Koordinate
  (setq einfpkt2d (list y x))			;Einfgepkt-2D
  (setq elev (caddr einfpkt))			;Erhebung-Hhe des 3D Punktes
  (setq pktnrdat (entget (entnext ename)))	;Daten der PktNr.
  (setq pktnr (cdr (assoc 1 pktnrdat)))		;PunktNr. (Attribut)
  (setq hdat (entget (entnext (entnext ename))))   ;Daten der Hhe
  (setq h (cdr (assoc 1 hdat)))		;Hhe (Attribut)
  (cond
    ((= art 1) pktnr)
    ((= art 2) h)
    ((= art 3) y)
    ((= art 4) x)
    ((= art 5) elev)
    ((= art 6) einfpkt)
    ((= art 7) einfpkt2d)
    ((= art T) nil)
  )
)
;---------------------------------------------------------------------------
(defun plist (ename)
  (setq elist (entget ename))
  (setq geschlossen (cdr (assoc 70 eliste)))
  (setq pktlist nil)
  (while elist
    (if (/= (caar elist) 10)
      (setq elist (cdr elist))
      (progn
        (setq pktlist (append pktlist (list (cdr (assoc 10 elist)))))
        (setq elist (cdr elist))
      )
    )
  )
  pktlist
)
;-------------------------------------------------------------------
(defun polyanalyse (ppkt pktlist / x1 pktanzvppkt)
  (setq x1 (ssnamex (ssget ppkt)))
  (setq pktanzvppkt (caddar x1))
  (repeat pktanzvppkt
    (setq p1 (car pktlist))
    (setq pktlist (cdr pktlist))
    (setq p2 (car pktlist))
  )
)
;-------------------------------------------------------------------
(defun para (/ P11)
  (setq P1 (car pktlist))
  (princ "\nParallel zu zwei Punkten")
  (setq P11 (getpoint "\nErster Punkt: "))
  (setq P2 (getpoint P11 "\nZweiter Punkt: "))
  (setq P1P2 (distance P11 P2))
  (princ "\nEntfernung: ")
  (princ P1P2)
  (princ "m oder in cm: ")
  (princ (/ P1P2 (/ (scale) 100)))
  (setq p1p0 (getdist "\nWie weit <Eingabe in cm>:"))
  (if (not p1p0)
    (setq p1p0 (zenti))
  )
  (setq npkt (polar P1 (angle P11 P2) p1p0))
)
;-------------------------------------------------------------------
(defun zenti ()
  (* (getint "\nWieviele Zentimeter:") (/ (scale) 100))
)
;-------------------------------------------------------------------
; Diese Funktion gibt den Mastab zurck - ermglicht die cm-Eingaben
; bei Bedarf an eigene Bedrfnisse anpassen
(defun scale ()
  1.0		; Wert mu "real" sein, sonst Div. durch 0
)
;-------------------------------------------------------------------
(defun pktnummer ( / nr index name pktnr)
  (if (/= "" (setq nr (getstring "\nPunktnummer eintippen: ")))
    (progn
      (setq npkt nil)
      (setq index 0)
      (ausw)
      (setq name (ssname auswahl index))
      (while name
        (setq pktnr (cdr (assoc 1 (entget (entnext name)))))
        (if (= nr pktnr)
          (setq npkt (cdr (assoc 10 (entget name))))
        )
        (setq index (1+ index))
        (setq name (ssname auswahl index))
      )
      (if npkt
        npkt
        (progn
          (princ "\nPunkt nicht gefunden - Andere Pkt-Nummer eingeben: ")
          (pktnummer)
        )
      )
    )
    (cond 
      ((= pktanz 0)
        (initget 128 "A P Y")
        (setq anfpkt (getpoint "\n1***Pol(Y)linie/(A)ttribut/(P)ktnr/<<Anfangspunkt>>: "))		;Anfangspunkt
        (if (not anfpkt)
          (setq anfpkt (getvar "lastpoint"))
        )
        (setq npkt anfpkt)	;die Funktion '(abfrage)' arbeitet mit 'npkt'
        (abfrage)
      )
      ((= pktanz 1)
        (initget 128 "Z A P T PA")
        (setq npkt (getpoint (car pktlist) "\n2***Rich(T)ung/(PA)rallel/(A)ttribut/(P)ktnr/(Z)urck/<<Nchster Punkt>>: ")) 	;Zweiter Punkt
        (abfrage)
      )
      ((>= pktanz 2)
        (eingabe)
        (abfrage)
      )
    )
  )
)
;-------------------------------------
(defun ausw ( / block)
  (setq block "gdk*")
  (setq auswahl (ssget "X" (list (cons 2 block))))
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(princ)
(princ "\nStart mit: li ")
;****************************************************************************

